#include "chip.h"
#include "chip_clk_constraints.h"
#include "chip_init_faults.h"

#if CHIP_LTIMER_EN
    #include "lclock.h"
#endif

#if CHIP_CLK_HSE_EN
    #if CHIP_DEV_SUPPORT_HSE_IOSEL
        #if CHIP_CLK_HSE_PIN_PA0
            #if CHIP_CLK_HSE_MODE != CHIP_CLK_EXTMODE_CLOCK
                #error "PA0 only support external clock mode"
            #endif
            #define CHIP_RVAL_RCC_CR_HSE_IOSEL CHIP_REGFLDVAL_RCC_CR_HSE_IOSEL_PA0_DIG
        #else
            #if CHIP_CLK_HSE_MODE == CHIP_CLK_EXTMODE_CLOCK
                #define CHIP_RVAL_RCC_CR_HSE_IOSEL  CHIP_REGFLDVAL_RCC_CR_HSE_IOSEL_PF0_DIG
            #else
                #define CHIP_RVAL_RCC_CR_HSE_IOSEL  CHIP_REGFLDVAL_RCC_CR_HSE_IOSEL_PF0_ANA
            #endif
        #endif
    #else
        #if CHIP_CLK_HSE_PIN_PA0
            #error "PA0 is not supported as OSC_IN in selected chip"
        #endif
    #endif
#endif


#if CHIP_CLK_PLL_EN
    #if CHIP_CLK_PLL_PREDIV == 1
        #define CHIP_RVAL_RCC_CFGR_PLL_PRE   CHIP_REGFLDVAL_RCC_CFGR_PLL_PRE_1
    #elif CHIP_CLK_PLL_PREDIV == 2
        #define CHIP_RVAL_RCC_CFGR_PLL_PRE   CHIP_REGFLDVAL_RCC_CFGR_PLL_PRE_2
    #elif CHIP_CLK_PLL_PREDIV == 3
        #define CHIP_RVAL_RCC_CFGR_PLL_PRE   CHIP_REGFLDVAL_RCC_CFGR_PLL_PRE_3
    #elif CHIP_CLK_PLL_PREDIV == 4
        #define CHIP_RVAL_RCC_CFGR_PLL_PRE   CHIP_REGFLDVAL_RCC_CFGR_PLL_PRE_4
    #else
        #error invalid PLL prediv value
    #endif

    #if ((CHIP_CLK_PLL_MUL >= 3) && (CHIP_CLK_PLL_MUL <= 18))
        #define CHIP_RVAL_RCC_CFGR_PLL_MUL  (CHIP_CLK_PLL_MUL - 3)
    #else
        #error "Invalid PLL multiplier value"
    #endif

    #if CHIP_CLK_PLL_OUTDIV == 1
        #define CHIP_RVAL_RCC_CFGR_PLL_OUTDIV   CHIP_REGFLDVAL_RCC_CFGR_PLL_OUTDIV_1
    #elif CHIP_CLK_PLL_OUTDIV == 2
        #define CHIP_RVAL_RCC_CFGR_PLL_OUTDIV   CHIP_REGFLDVAL_RCC_CFGR_PLL_OUTDIV_2
    #elif CHIP_CLK_PLL_OUTDIV == 3
        #define CHIP_RVAL_RCC_CFGR_PLL_OUTDIV   CHIP_REGFLDVAL_RCC_CFGR_PLL_OUTDIV_3
    #elif CHIP_CLK_PLL_OUTDIV == 4
        #define CHIP_RVAL_RCC_CFGR_PLL_OUTDIV   CHIP_REGFLDVAL_RCC_CFGR_PLL_OUTDIV_4
    #else
        #error invalid PLL out div value
    #endif


    #if !CHIP_CLK_PLL_SRC_EN
        #error PLL clock source is not enabled
    #endif

    #if CHIP_CLK_PLL_SRC_ID == CHIP_CLK_HSI_ID
        #define CHIP_RVAL_RCC_CFGR_PLL_SRC   CHIP_REGFLDVAL_RCC_CFGR_PLL_SRC_HSI
    #elif CHIP_CLK_PLL_SRC_ID == CHIP_CLK_HSE_ID
        #define CHIP_RVAL_RCC_CFGR_PLL_SRC   CHIP_REGFLDVAL_RCC_CFGR_PLL_SRC_HSE
    #else
         #error Invalid PLL clock source
    #endif


    #if ((CHIP_CLK_PLL_IN_FREQ < CHIP_CLK_PLL_IN_FREQ_MIN) || (CHIP_CLK_PLL_IN_FREQ > CHIP_CLK_PLL_IN_FREQ_MAX))
        #error PLL input freq is out of range
    #endif
    #if ((CHIP_CLK_PLL_VCO_FREQ < CHIP_CLK_PLL_VCO_FREQ_MIN) || (CHIP_CLK_PLL_VCO_FREQ > CHIP_CLK_PLL_VCO_FREQ_MAX))
        #error PLL output freq is out of range
    #endif
    #if ((CHIP_CLK_PLL_FREQ < CHIP_CLK_PLL_FREQ_MIN) || (CHIP_CLK_PLL_FREQ > CHIP_CLK_PLL_FREQ_MAX))
        #error PLL output freq is out of range
    #endif
#endif




/* --------------------- Проверка параметров SystemClock -------------------- */
#if CHIP_CLK_SYS_SRC_ID == CHIP_CLK_HSI_ID
    #define CHIP_RVAL_RCC_CFGR_SW    CHIP_REGFLDVAL_RCC_CFGR_SW_HSI
#elif CHIP_CLK_SYS_SRC_ID == CHIP_CLK_HSE_ID
    #define CHIP_RVAL_RCC_CFGR_SW    CHIP_REGFLDVAL_RCC_CFGR_SW_HSE
#elif CHIP_CLK_SYS_SRC_ID == CHIP_CLK_PLL_ID
    #define CHIP_RVAL_RCC_CFGR_SW    CHIP_REGFLDVAL_RCC_CFGR_SW_PLL
#elif CHIP_CLK_SYS_SRC_ID == CHIP_CLK_LSE_ID
    #define CHIP_RVAL_RCC_CFGR_SW    CHIP_REGFLDVAL_RCC_CFGR_SW_LSE
#elif CHIP_CLK_SYS_SRC_ID == CHIP_CLK_LSI_ID
    #define CHIP_RVAL_RCC_CFGR_SW    CHIP_REGFLDVAL_RCC_CFGR_SW_LSI
#else
    #error Invalid System Clock Source (must be from HSI, HSE, PLL, LSE, LSI)
#endif

#if !CHIP_CLK_SYS_EN
    #error System clock source is not enabled
#endif


/* -------------------- Проверка частот AHB ----------------------------------*/
#if CHIP_CLK_AHB_DIV == 1
    #define CHIP_RVAL_RCC_CFGR_AHB_PRE             CHIP_REGFLDVAL_RCC_CFGR_AHB_PRE_1
#elif CHIP_CLK_AHB_DIV == 2
    #define CHIP_RVAL_RCC_CFGR_AHB_PRE             CHIP_REGFLDVAL_RCC_CFGR_AHB_PRE_2
#elif CHIP_CLK_AHB_DIV == 4
    #define CHIP_RVAL_RCC_CFGR_AHB_PRE             CHIP_REGFLDVAL_RCC_CFGR_AHB_PRE_4
#elif CHIP_CLK_AHB_DIV == 8
    #define CHIP_RVAL_RCC_CFGR_AHB_PRE             CHIP_REGFLDVAL_RCC_CFGR_AHB_PRE_8
#elif CHIP_CLK_AHB_DIV == 16
    #define CHIP_RVAL_RCC_CFGR_AHB_PRE             CHIP_REGFLDVAL_RCC_CFGR_AHB_PRE_16
#elif CHIP_CLK_AHB_DIV == 64
    #define CHIP_RVAL_RCC_CFGR_AHB_PRE             CHIP_REGFLDVAL_RCC_CFGR_AHB_PRE_64
#elif CHIP_CLK_AHB_DIV == 128
    #define CHIP_RVAL_RCC_CFGR_AHB_PRE             CHIP_REGFLDVAL_RCC_CFGR_AHB_PRE_128
#elif CHIP_CLK_AHB_DIV == 256
    #define CHIP_RVAL_RCC_CFGR_AHB_PRE             CHIP_REGFLDVAL_RCC_CFGR_AHB_PRE_256
#elif CHIP_CLK_AHB_DIV == 512
    #define CHIP_RVAL_RCC_CFGR_AHB_PRE             CHIP_REGFLDVAL_RCC_CFGR_AHB_PRE_512
#else
    #error invalid AHB clock divider
#endif

#if CHIP_CLK_AHB_FREQ > CHIP_CLK_AHB_FREQ_MAX
    #error AHB freq is out of range
#endif

/* -------------------- Проверка частот APB1/APB2 ----------------------------*/
#if CHIP_CLK_APB1_DIV == 1
    #define CHIP_RVAL_RCC_CFGR_APB1_PRE             CHIP_REGFLDVAL_RCC_CFGR_APB_PRE_1
#elif CHIP_CLK_APB1_DIV == 2
    #define CHIP_RVAL_RCC_CFGR_APB1_PRE             CHIP_REGFLDVAL_RCC_CFGR_APB_PRE_2
#elif CHIP_CLK_APB1_DIV == 4
    #define CHIP_RVAL_RCC_CFGR_APB1_PRE             CHIP_REGFLDVAL_RCC_CFGR_APB_PRE_4
#elif CHIP_CLK_APB1_DIV == 8
    #define CHIP_RVAL_RCC_CFGR_APB1_PRE             CHIP_REGFLDVAL_RCC_CFGR_APB_PRE_8
#elif CHIP_CLK_APB1_DIV == 16
    #define CHIP_RVAL_RCC_CFGR_APB1_PRE             CHIP_REGFLDVAL_RCC_CFGR_APB_PRE_16
#else
    #error invalid APB1 clock divider
#endif

#if CHIP_CLK_APB1_FREQ > CHIP_CLK_APB1_FREQ_MAX
    #error APB freq is out of range
#endif

#if CHIP_CLK_APB2_DIV == 1
    #define CHIP_RVAL_RCC_CFGR_APB2_PRE             CHIP_REGFLDVAL_RCC_CFGR_APB_PRE_1
#elif CHIP_CLK_APB2_DIV == 2
    #define CHIP_RVAL_RCC_CFGR_APB2_PRE             CHIP_REGFLDVAL_RCC_CFGR_APB_PRE_2
#elif CHIP_CLK_APB2_DIV == 4
    #define CHIP_RVAL_RCC_CFGR_APB2_PRE             CHIP_REGFLDVAL_RCC_CFGR_APB_PRE_4
#elif CHIP_CLK_APB2_DIV == 8
    #define CHIP_RVAL_RCC_CFGR_APB2_PRE             CHIP_REGFLDVAL_RCC_CFGR_APB_PRE_8
#elif CHIP_CLK_APB2_DIV == 16
    #define CHIP_RVAL_RCC_CFGR_APB2_PRE             CHIP_REGFLDVAL_RCC_CFGR_APB_PRE_16
#else
    #error invalid APB2 clock divider
#endif

#if CHIP_CLK_APB2_FREQ > CHIP_CLK_APB2_FREQ_MAX
    #error APB freq is out of range
#endif

/* определение MCO */
#if CHIP_CFG_CLK_MCO_EN
    #if CHIP_CLK_MCO_SRC_ID == CHIP_CLK_LSI_ID
        #define CHIP_RVAL_RCC_CFGR_MCO   CHIP_REGFLDVAL_RCC_CFGR_MCO_LSI
    #elif CHIP_CLK_MCO_SRC_ID == CHIP_CLK_LSE_ID
        #define CHIP_RVAL_RCC_CFGR_MCO   CHIP_REGFLDVAL_RCC_CFGR_MCO_LSE
    #elif CHIP_CLK_MCO_SRC_ID == CHIP_CLK_SYS_ID
        #define CHIP_RVAL_RCC_CFGR_MCO   CHIP_REGFLDVAL_RCC_CFGR_MCO_SYS
    #elif CHIP_CLK_MCO_SRC_ID == CHIP_CLK_HSI_ID
        #define CHIP_RVAL_RCC_CFGR_MCO   CHIP_REGFLDVAL_RCC_CFGR_MCO_HSI
    #elif CHIP_CLK_MCO_SRC_ID == CHIP_CLK_HSE_ID
        #define CHIP_RVAL_RCC_CFGR_MCO   CHIP_REGFLDVAL_RCC_CFGR_MCO_HSE
    #elif CHIP_CLK_MCO_SRC_ID == CHIP_CLK_PLL_ID
        #define CHIP_RVAL_RCC_CFGR_MCO   CHIP_REGFLDVAL_RCC_CFGR_MCO_PLL
    #else
        #error Invalid MCO Source (must be from LSI, LSE, SYS, HSI, HSE, PLL)
    #endif

    #if !CHIP_CLK_MCO_SRC_EN
        #error MCO source is not eneabled
    #endif

    #if (CHIP_CLK_MCO_PLL_DIV < CHIP_REGFLDVAL_RCC_CFGR_MCO_PRE_MIN) || (CHIP_CLK_MCO_PLL_DIV > CHIP_REGFLDVAL_RCC_CFGR_MCO_PRE_MAX)
        #error invalid MCO PLL DIV value
    #else
        #define CHIP_RVAL_RCC_CFGR_MCO_PRE  CHIP_CLK_MCO_PLL_DIV
    #endif
#else
    #define CHIP_RVAL_RCC_CFGR_MCO      CHIP_REGFLDVAL_RCC_CFGR_MCO_DIS
    #define CHIP_RVAL_RCC_CFGR_MCO_PRE  CHIP_REGFLDVAL_RCC_CFGR_MCO_PRE_MIN
#endif

#if !CHIP_CLK_MCO_SRC_EN
    #error MCO source is not eneabled
#endif

#if (CHIP_CLK_MCO_PLL_DIV < CHIP_REGFLDVAL_RCC_CFGR_MCO_PRE_MIN) || (CHIP_CLK_MCO_PLL_DIV > CHIP_REGFLDVAL_RCC_CFGR_MCO_PRE_MAX)
    #error invalid MCO PLL DIV value
#else
    #define CHIP_RVAL_RCC_CFGR_MCO_PRE  CHIP_CLK_MCO_PLL_DIV
#endif


#if CHIP_CLK_LPUART1_SRC_ID == CHIP_CLK_APB1_ID
    #define CHIP_RVAL_RCC_CFGR2_LPUART1     CHIP_REGFLDVAL_RCC_CFGR2_LPUART_SEL_APB1
#elif CHIP_CLK_LPUART1_SRC_ID == CHIP_CLK_SYS_ID
    #define CHIP_RVAL_RCC_CFGR2_LPUART1     CHIP_REGFLDVAL_RCC_CFGR2_LPUART_SEL_SYSCLK
#elif CHIP_CLK_LPUART1_SRC_ID == CHIP_CLK_HSI_ID
    #define CHIP_RVAL_RCC_CFGR2_LPUART1     CHIP_REGFLDVAL_RCC_CFGR2_LPUART_SEL_HSI
#elif CHIP_CLK_LPUART1_SRC_ID == CHIP_CLK_HSE_ID
    #define CHIP_RVAL_RCC_CFGR2_LPUART1     CHIP_REGFLDVAL_RCC_CFGR2_LPUART_SEL_HSE
#elif CHIP_CLK_LPUART1_SRC_ID == CHIP_CLK_LSI_ID
    #define CHIP_RVAL_RCC_CFGR2_LPUART1     CHIP_REGFLDVAL_RCC_CFGR2_LPUART_SEL_LSI
#elif CHIP_CLK_LPUART1_SRC_ID == CHIP_CLK_LSE_ID
    #define CHIP_RVAL_RCC_CFGR2_LPUART1     CHIP_REGFLDVAL_RCC_CFGR2_LPUART_SEL_LSE
#else
    #error Invalid LPUART1 frequency source (must be from APB1, SYS, HSI, HSE, LSI, LSE)
#endif

#if CHIP_DEV_LPUART_CNT >= 2
    #if CHIP_CLK_LPUART2_SRC_ID == CHIP_CLK_APB1_ID
        #define CHIP_RVAL_RCC_CFGR2_LPUART2     CHIP_REGFLDVAL_RCC_CFGR2_LPUART_SEL_APB1
    #elif CHIP_CLK_LPUART2_SRC_ID == CHIP_CLK_SYS_ID
        #define CHIP_RVAL_RCC_CFGR2_LPUART2     CHIP_REGFLDVAL_RCC_CFGR2_LPUART_SEL_SYSCLK
    #elif CHIP_CLK_LPUART2_SRC_ID == CHIP_CLK_HSI_ID
        #define CHIP_RVAL_RCC_CFGR2_LPUART2     CHIP_REGFLDVAL_RCC_CFGR2_LPUART_SEL_HSI
    #elif CHIP_CLK_LPUART2_SRC_ID == CHIP_CLK_HSE_ID
        #define CHIP_RVAL_RCC_CFGR2_LPUART2     CHIP_REGFLDVAL_RCC_CFGR2_LPUART_SEL_HSE
    #elif CHIP_CLK_LPUART2_SRC_ID == CHIP_CLK_LSI_ID
        #define CHIP_RVAL_RCC_CFGR2_LPUART2     CHIP_REGFLDVAL_RCC_CFGR2_LPUART_SEL_LSI
    #elif CHIP_CLK_LPUART2_SRC_ID == CHIP_CLK_LSE_ID
        #define CHIP_RVAL_RCC_CFGR2_LPUART2     CHIP_REGFLDVAL_RCC_CFGR2_LPUART_SEL_LSE
    #else
        #error Invalid LPUART2 frequency source (must be from APB1, SYS, HSI, HSE, LSI, LSE)
    #endif
#endif

#if CHIP_CLK_LPTIM_SRC_ID == CHIP_CLK_APB1_ID
    #define CHIP_RVAL_RCC_CFGR2_LPTIM   CHIP_REGFLDVAL_RCC_CFGR2_LPTIM_SEL_APB1
#elif CHIP_CLK_LPTIM_SRC_ID == CHIP_CLK_HSI_ID
    #define CHIP_RVAL_RCC_CFGR2_LPTIM   CHIP_REGFLDVAL_RCC_CFGR2_LPTIM_SEL_HSI
#elif CHIP_CLK_LPTIM_SRC_ID == CHIP_CLK_HSE_ID
    #define CHIP_RVAL_RCC_CFGR2_LPTIM   CHIP_REGFLDVAL_RCC_CFGR2_LPTIM_SEL_HSE
#elif CHIP_CLK_LPTIM_SRC_ID == CHIP_CLK_LSI_ID
    #define CHIP_RVAL_RCC_CFGR2_LPTIM   CHIP_REGFLDVAL_RCC_CFGR2_LPTIM_SEL_LSI
#elif CHIP_CLK_LPTIM_SRC_ID == CHIP_CLK_LSE_ID
    #define CHIP_RVAL_RCC_CFGR2_LPTIM   CHIP_REGFLDVAL_RCC_CFGR2_LPTIM_SEL_LSE
#elif CHIP_CLK_LPTIM_SRC_ID == CHIP_CLK_COMP_ID
    #define CHIP_RVAL_RCC_CFGR2_LPTIM   CHIP_REGFLDVAL_RCC_CFGR2_LPTIM_SEL_COMP
#else
    #error Invalid LPTIM frequency source (must be from APB1, HSI, HSE, LSI, LSE, COMP)
#endif

#if CHIP_CLK_TIM1_8_SRC_ID == CHIP_CLK_APB2_TIM_ID
    #define CHIP_RVAL_RCC_CFGR2_TIM     CHIP_REGFLDVAL_RCC_CFGR2_TIM_SEL_TIMCLK
#elif CHIP_CLK_LPTIM_SRC_ID == CHIP_CLK_SYS_ID
    #define CHIP_RVAL_RCC_CFGR2_TIM     CHIP_REGFLDVAL_RCC_CFGR2_TIM_SEL_SYSCLK
#else
    #error Invalid TIM1/8 frequency source (must be from APB2_TIM or SYS)
#endif


#if CHIP_DEV_SUPPORT_RNG
#if (CHIP_CLK_RNG_PREDIV >= 1) && (CHIP_CLK_RNG_PREDIV <= 32)
    #define CHIP_RVAL_RCC_CFGR2_RNG_PRE  (CHIP_CLK_RNG_PREDIV-1)
#else
    #error invalid RNG frequency pre-divider (must be 1..32)
#endif
#endif



#if CHIP_CLK_ADC_PLL_DIV == 0
    #define CHIP_RVAL_RCC_CFGR2_ADC_PLL_PRE     CHIP_REGFLDVAL_RCC_CFGR2_ADC_PLL_PRE_DIS
#elif CHIP_CLK_ADC_PLL_DIV == 1
    #define CHIP_RVAL_RCC_CFGR2_ADC_PLL_PRE     CHIP_REGFLDVAL_RCC_CFGR2_ADC_PLL_PRE_1
#elif CHIP_CLK_ADC_PLL_DIV == 2
    #define CHIP_RVAL_RCC_CFGR2_ADC_PLL_PRE     CHIP_REGFLDVAL_RCC_CFGR2_ADC_PLL_PRE_2
#elif CHIP_CLK_ADC_PLL_DIV == 3
    #define CHIP_RVAL_RCC_CFGR2_ADC_PLL_PRE     CHIP_REGFLDVAL_RCC_CFGR2_ADC_PLL_PRE_3
#elif CHIP_CLK_ADC_PLL_DIV == 4
    #define CHIP_RVAL_RCC_CFGR2_ADC_PLL_PRE     CHIP_REGFLDVAL_RCC_CFGR2_ADC_PLL_PRE_4
#elif CHIP_CLK_ADC_PLL_DIV == 6
    #define CHIP_RVAL_RCC_CFGR2_ADC_PLL_PRE     CHIP_REGFLDVAL_RCC_CFGR2_ADC_PLL_PRE_6
#elif CHIP_CLK_ADC_PLL_DIV == 8
    #define CHIP_RVAL_RCC_CFGR2_ADC_PLL_PRE     CHIP_REGFLDVAL_RCC_CFGR2_ADC_PLL_PRE_8
#elif CHIP_CLK_ADC_PLL_DIV == 10
    #define CHIP_RVAL_RCC_CFGR2_ADC_PLL_PRE     CHIP_REGFLDVAL_RCC_CFGR2_ADC_PLL_PRE_10
#elif CHIP_CLK_ADC_PLL_DIV == 12
    #define CHIP_RVAL_RCC_CFGR2_ADC_PLL_PRE     CHIP_REGFLDVAL_RCC_CFGR2_ADC_PLL_PRE_12
#elif CHIP_CLK_ADC_PLL_DIV == 16
    #define CHIP_RVAL_RCC_CFGR2_ADC_PLL_PRE     CHIP_REGFLDVAL_RCC_CFGR2_ADC_PLL_PRE_16
#elif CHIP_CLK_ADC_PLL_DIV == 32
    #define CHIP_RVAL_RCC_CFGR2_ADC_PLL_PRE     CHIP_REGFLDVAL_RCC_CFGR2_ADC_PLL_PRE_32
#elif CHIP_CLK_ADC_PLL_DIV == 64
    #define CHIP_RVAL_RCC_CFGR2_ADC_PLL_PRE     CHIP_REGFLDVAL_RCC_CFGR2_ADC_PLL_PRE_64
#elif CHIP_CLK_ADC_PLL_DIV == 128
    #define CHIP_RVAL_RCC_CFGR2_ADC_PLL_PRE     CHIP_REGFLDVAL_RCC_CFGR2_ADC_PLL_PRE_128
#elif CHIP_CLK_ADC_PLL_DIV == 256
    #define CHIP_RVAL_RCC_CFGR2_ADC_PLL_PRE     CHIP_REGFLDVAL_RCC_CFGR2_ADC_PLL_PRE_256
#else
    #error "Invalid ADC PLL Prescaler value"
#endif


#if CHIP_CLK_ADC_HCLK_DIV == 1
    #define CHIP_RVAL_RCC_CFGR2_ADC_HPRE     CHIP_REGFLDVAL_RCC_CFGR2_ADC_HPRE_1
#elif CHIP_CLK_ADC_HCLK_DIV == 2
    #define CHIP_RVAL_RCC_CFGR2_ADC_HPRE     CHIP_REGFLDVAL_RCC_CFGR2_ADC_HPRE_2
#elif CHIP_CLK_ADC_HCLK_DIV == 3
    #define CHIP_RVAL_RCC_CFGR2_ADC_HPRE     CHIP_REGFLDVAL_RCC_CFGR2_ADC_HPRE_3
#elif CHIP_CLK_ADC_HCLK_DIV == 4
    #define CHIP_RVAL_RCC_CFGR2_ADC_HPRE     CHIP_REGFLDVAL_RCC_CFGR2_ADC_HPRE_4
#elif CHIP_CLK_ADC_HCLK_DIV == 6
    #define CHIP_RVAL_RCC_CFGR2_ADC_HPRE     CHIP_REGFLDVAL_RCC_CFGR2_ADC_HPRE_6
#elif CHIP_CLK_ADC_HCLK_DIV == 8
    #define CHIP_RVAL_RCC_CFGR2_ADC_HPRE     CHIP_REGFLDVAL_RCC_CFGR2_ADC_HPRE_8
#elif CHIP_CLK_ADC_HCLK_DIV == 10
    #define CHIP_RVAL_RCC_CFGR2_ADC_HPRE     CHIP_REGFLDVAL_RCC_CFGR2_ADC_HPRE_10
#elif CHIP_CLK_ADC_HCLK_DIV == 12
    #define CHIP_RVAL_RCC_CFGR2_ADC_HPRE     CHIP_REGFLDVAL_RCC_CFGR2_ADC_HPRE_12
#elif CHIP_CLK_ADC_HCLK_DIV == 16
    #define CHIP_RVAL_RCC_CFGR2_ADC_HPRE     CHIP_REGFLDVAL_RCC_CFGR2_ADC_HPRE_16
#elif CHIP_CLK_ADC_HCLK_DIV == 32
    #define CHIP_RVAL_RCC_CFGR2_ADC_HPRE     CHIP_REGFLDVAL_RCC_CFGR2_ADC_HPRE_32
#else
    #error "Invalid ADC HCLK Prescaler value"
#endif


#if CHIP_CLK_ADC_SRC_ID == CHIP_CLK_ADC_HCLK_ID
    #define CHIP_RVAL_ADC_CR3_CKMOD     CHIP_REGFLDVAL_ADC_CR3_CKMOD_AHB
#elif CHIP_CLK_ADC_SRC_ID == CHIP_CLK_ADC_PLL_ID
    #define CHIP_RVAL_ADC_CR3_CKMOD     CHIP_REGFLDVAL_ADC_CR3_CKMOD_PLL
#else
    #error Invalid ADC frequency source (must be from ADC_HCLK, ADC_PLL)
#endif


#if CHIP_CLK_ADC_1M_SRC_ID == CHIP_CLK_HSI_ID
    #define CHIP_RVAL_RCC_CFGR2_ADC_1M_SEL     CHIP_REGFLDVAL_RCC_CFGR2_ADC_1M_SEL_HSI
#elif CHIP_CLK_ADC_1M_SRC_ID == CHIP_CLK_HSE_ID
    #define CHIP_RVAL_RCC_CFGR2_ADC_1M_SEL     CHIP_REGFLDVAL_RCC_CFGR2_ADC_1M_SEL_HSE
#else
    #error Invalid ADC 1M frequency source (must be from HSI, HSE)
#endif

#if (CHIP_CLK_ADC_1M_DIV >= 1) && (CHIP_CLK_ADC_1M_DIV <= 32)
    #define CHIP_RVAL_RCC_CFGR2_ADC_1M_PRE (CHIP_CLK_ADC_1M_DIV - 1)
#else
    #error invalid ADC CLK 1M frequency pre-divider (must be 1..32)
#endif

#if CHIP_CLK_ADC_EN
    #if (CHIP_CLK_ADC_FREQ > CHIP_CLK_ADC_FREQ_MAX)
        #error ADC freq is out of range
    #endif
#endif





void chip_clk_init(void) {
    /* Если процессор работает не от HSI, то переходим в режим по умолчанию:
     * включаем HSI и ждем готовности, переводим процессор на работу от него */
    if (CHIP_REGFLDGET_RCC_CFGR_SWS(CHIP_REGS_RCC->CFGR) != CHIP_REGFLDVAL_RCC_CFGR_SW_HSI) {
        CHIP_REGS_RCC->CR |= CHIP_REGFLD_RCC_CR_HSI_ON;


        CHIP_INIT_WAIT((CHIP_REGS_RCC->CR & CHIP_REGFLD_RCC_CR_HSI_RDY) == CHIP_REGFLD_RCC_CR_HSI_RDY,
                           CHIP_INIT_FAULT_WAIT_HSI_RDY, 10000);

        LBITFIELD_UPD(CHIP_REGS_RCC->CFGR, CHIP_REGFLD_RCC_CFGR_SW, CHIP_REGFLDVAL_RCC_CFGR_SW_HSI);
    }


#if CHIP_CLK_HSE_EN
#if CHIP_CLK_HSE_PIN_PA0
    CHIP_PIN_CONFIG(CHIP_PIN_PA0_OSC_IN);
#else
    CHIP_PIN_CONFIG(CHIP_PIN_PF0_OSC_IN);
#if (CHIP_CLK_HSE_MODE == CHIP_CLK_EXTMODE_OSC)
    CHIP_PIN_CONFIG(CHIP_PIN_PF1_OSC_OUT);
#endif
#endif


    CHIP_REGS_RCC->CR = (CHIP_REGS_RCC->CR & (CHIP_REGMSK_RCC_CR_RESERVED | CHIP_REGFLD_RCC_CR_HSI_TRIM))
            | CHIP_REGFLD_RCC_CR_HSI_ON
        #if CHIP_CLK_HSE_EN
            | CHIP_REGFLD_RCC_CR_HSE_ON
        #if (CHIP_CLK_HSE_MODE == CHIP_CLK_EXTMODE_CLOCK) && !CHIP_DEV_SUPPORT_HSE_IOSEL
            | CHIP_REGFLD_RCC_CR_HSE_BYP
        #endif
        #if CHIP_CLK_HSE_CSS_EN
            | CHIP_REGFLD_RCC_CR_CSS_ON
        #endif
        #if CHIP_DEV_SUPPORT_HSE_IOSEL && CHIP_CLK_HSE_EN
            LBITFIELD_SET(CHIP_REGFLD_RCC_CR_HSE_IOSEL, CHIP_RVAL_RCC_CR_HSE_IOSEL)
        #endif
        #endif
            ;



    CHIP_INIT_WAIT((CHIP_REGS_RCC->CR & CHIP_REGFLD_RCC_CR_HSE_RDY) == CHIP_REGFLD_RCC_CR_HSE_RDY,
                       CHIP_INIT_FAULT_WAIT_HSE_RDY, 10000);
#endif

#if CHIP_CLK_PLL_EN
    /* настройка PLL если требуется */
    CHIP_REGS_RCC->CFGR = (CHIP_REGS_RCC->CFGR & ~(CHIP_REGFLD_RCC_CFGR_PLL_MUL
                               | CHIP_REGFLD_RCC_CFGR_PLL_PRE
                               | CHIP_REGFLD_RCC_CFGR_PLL_OUTDIV
                               | CHIP_REGFLD_RCC_CFGR_PLL_SRC))
            | LBITFIELD_SET(CHIP_REGFLD_RCC_CFGR_PLL_MUL,       CHIP_RVAL_RCC_CFGR_PLL_MUL)
            | LBITFIELD_SET(CHIP_REGFLD_RCC_CFGR_PLL_PRE,       CHIP_RVAL_RCC_CFGR_PLL_PRE)
            | LBITFIELD_SET(CHIP_REGFLD_RCC_CFGR_PLL_OUTDIV,    CHIP_RVAL_RCC_CFGR_PLL_OUTDIV)
            | LBITFIELD_SET(CHIP_REGFLD_RCC_CFGR_PLL_SRC,       CHIP_RVAL_RCC_CFGR_PLL_SRC)
            ;

    CHIP_REGS_RCC->CR |= CHIP_REGFLD_RCC_CR_PLL_EN | CHIP_REGFLD_RCC_CR_PLL_OUT_EN
            | LBITFIELD_SET(CHIP_REGFLD_RCC_CR_PLL_BP, CHIP_CLK_PLL_BYPASS);

    CHIP_INIT_WAIT((CHIP_REGS_RCC->CR & CHIP_REGFLD_RCC_CR_PLL_RDY) == CHIP_REGFLD_RCC_CR_PLL_RDY,
                   CHIP_INIT_FAULT_WAIT_PLL_RDY, 10000);
#endif


    /* перед настройкой SYS_CLK устанавливаем нужные параметры LATENCY для flash */
    chip_flash_init();

    /* выбор источника системного клока и делителей шин */
    CHIP_REGS_RCC->CFGR = (CHIP_REGS_RCC->CFGR & ~(CHIP_REGFLD_RCC_CFGR_SW
                               | CHIP_REGFLD_RCC_CFGR_AHB_PRE
                               | CHIP_REGFLD_RCC_CFGR_APB1_PRE
                               | CHIP_REGFLD_RCC_CFGR_APB2_PRE
                               | CHIP_RVAL_RCC_CFGR_MCO
                               | CHIP_RVAL_RCC_CFGR_MCO_PRE))
            | LBITFIELD_SET(CHIP_REGFLD_RCC_CFGR_SW,        CHIP_RVAL_RCC_CFGR_SW)
            | LBITFIELD_SET(CHIP_REGFLD_RCC_CFGR_AHB_PRE,   CHIP_RVAL_RCC_CFGR_AHB_PRE)
            | LBITFIELD_SET(CHIP_REGFLD_RCC_CFGR_APB1_PRE,  CHIP_RVAL_RCC_CFGR_APB1_PRE)
            | LBITFIELD_SET(CHIP_REGFLD_RCC_CFGR_APB2_PRE,  CHIP_RVAL_RCC_CFGR_APB2_PRE)
            | LBITFIELD_SET(CHIP_REGFLD_RCC_CFGR_MCO,       CHIP_RVAL_RCC_CFGR_MCO)
            | LBITFIELD_SET(CHIP_REGFLD_RCC_CFGR_MCO_PRE,   CHIP_RVAL_RCC_CFGR_MCO_PRE)
            ;

    CHIP_REGS_RCC->CFGR2 =  (CHIP_REGS_RCC->CFGR & ~(CHIP_REGFLD_RCC_CFGR2_LPUART1_SEL
#if CHIP_DEV_LPUART_CNT >= 2
                                                     | CHIP_REGFLD_RCC_CFGR2_LPUART2_SEL
#endif
                                                     | CHIP_REGFLD_RCC_CFGR2_LPTIM_SEL
                                                     | CHIP_REGFLD_RCC_CFGR2_TIM_SEL
#if CHIP_DEV_SUPPORT_RNG
                                                     | CHIP_REGFLD_RCC_CFGR2_RNG_PRE
                                                     | CHIP_REGFLD_RCC_CFGR2_RNG_AN_EN
#endif
                                                     | CHIP_REGFLD_RCC_CFGR2_ADC_HPRE
                                                     | CHIP_REGFLD_RCC_CFGR2_ADC_PLL_PRE
                                                     | CHIP_REGFLD_RCC_CFGR2_ADC_1M_SEL
                                                     | CHIP_REGFLD_RCC_CFGR2_ADC_1M_PRE
                                                     ))
            | LBITFIELD_SET(CHIP_REGFLD_RCC_CFGR2_LPUART1_SEL,  CHIP_RVAL_RCC_CFGR2_LPUART1)
#if CHIP_DEV_LPUART_CNT >= 2
            | LBITFIELD_SET(CHIP_REGFLD_RCC_CFGR2_LPUART2_SEL,  CHIP_RVAL_RCC_CFGR2_LPUART2)
#endif
            | LBITFIELD_SET(CHIP_REGFLD_RCC_CFGR2_LPTIM_SEL,    CHIP_RVAL_RCC_CFGR2_LPTIM)
            | LBITFIELD_SET(CHIP_REGFLD_RCC_CFGR2_TIM_SEL,      CHIP_RVAL_RCC_CFGR2_TIM)
#if CHIP_DEV_SUPPORT_RNG
            | LBITFIELD_SET(CHIP_REGFLD_RCC_CFGR2_RNG_PRE,      CHIP_RVAL_RCC_CFGR2_RNG_PRE)
            | LBITFIELD_SET(CHIP_REGFLD_RCC_CFGR2_RNG_AN_EN,    CHIP_CLK_RNG_EN)
#endif
            | LBITFIELD_SET(CHIP_REGFLD_RCC_CFGR2_ADC_HPRE,     CHIP_RVAL_RCC_CFGR2_ADC_HPRE)
            | LBITFIELD_SET(CHIP_REGFLD_RCC_CFGR2_ADC_PLL_PRE,  CHIP_RVAL_RCC_CFGR2_ADC_PLL_PRE)
            | LBITFIELD_SET(CHIP_REGFLD_RCC_CFGR2_ADC_1M_SEL,   CHIP_RVAL_RCC_CFGR2_ADC_1M_SEL)
            | LBITFIELD_SET(CHIP_REGFLD_RCC_CFGR2_ADC_1M_PRE,   CHIP_RVAL_RCC_CFGR2_ADC_1M_PRE)
            ;


    CHIP_REGS_RCC->AHBENR = (CHIP_REGS_RCC->AHBENR & ~CHIP_REGMSK_RCC_AHBENR_RESERVED)
            | LBITFIELD_SET(CHIP_REGFLD_RCC_AHBENR_DMA_EN,      CHIP_CLK_DMA_EN)
            | LBITFIELD_SET(CHIP_REGFLD_RCC_AHBENR_SRAM_EN,     CHIP_CLK_SRAM_EN)
            | LBITFIELD_SET(CHIP_REGFLD_RCC_AHBENR_FLITF_EN,    CHIP_CLK_FLASH_EN)
            | LBITFIELD_SET(CHIP_REGFLD_RCC_AHBENR_HSQRT_EN,    CHIP_CLK_HSQRT_EN)
            | LBITFIELD_SET(CHIP_REGFLD_RCC_AHBENR_CRC_EN,      CHIP_CLK_CRC_EN)
            | LBITFIELD_SET(CHIP_REGFLD_RCC_AHBENR_HDIV_EN,     CHIP_CLK_HDIV_EN)
#if CHIP_DEV_SUPPORT_RNG
            | LBITFIELD_SET(CHIP_REGFLD_RCC_AHBENR_RNG_EN,      CHIP_CLK_RNG_EN)
#endif
#if CHIP_DEV_SUPPORT_SAC
            | LBITFIELD_SET(CHIP_REGFLD_RCC_AHBENR_SAC_EN,      CHIP_CLK_SAC_EN)
#endif
            | LBITFIELD_SET(CHIP_REGFLD_RCC_AHBENR_ADC_EN,      CHIP_CLK_ADC_EN)
            ;

    CHIP_REGS_RCC->APB2ENR |=  (CHIP_REGS_RCC->APB2ENR & ~CHIP_REGMSK_RCC_APB2ENR_RESERVED)
            | LBITFIELD_SET(CHIP_REGFLD_RCC_APB2ENR_AFIO_EN,    CHIP_CLK_AFIO_EN)
            | LBITFIELD_SET(CHIP_REGFLD_RCC_APB2ENR_IOPA_EN,    CHIP_CLK_GPIOA_EN)
            | LBITFIELD_SET(CHIP_REGFLD_RCC_APB2ENR_IOPB_EN,    CHIP_CLK_GPIOB_EN)
            | LBITFIELD_SET(CHIP_REGFLD_RCC_APB2ENR_IOPC_EN,    CHIP_CLK_GPIOC_EN)
#if CHIP_DEV_SUPPORT_PORTD
            | LBITFIELD_SET(CHIP_REGFLD_RCC_APB2ENR_IOPD_EN,    CHIP_CLK_GPIOD_EN)
#endif
            | LBITFIELD_SET(CHIP_REGFLD_RCC_APB2ENR_IOPF_EN,    CHIP_CLK_GPIOF_EN)
            | LBITFIELD_SET(CHIP_REGFLD_RCC_APB2ENR_SPI1_EN,    CHIP_CLK_SPI1_EN)
            | LBITFIELD_SET(CHIP_REGFLD_RCC_APB2ENR_SPI2_EN,    CHIP_CLK_SPI2_EN)
#if CHIP_DEV_SPI_CNT >= 3
            | LBITFIELD_SET(CHIP_REGFLD_RCC_APB2ENR_SPI3_EN,    CHIP_CLK_SPI3_EN)
#endif
            | LBITFIELD_SET(CHIP_REGFLD_RCC_APB2ENR_TIM1_EN,    CHIP_CLK_TIM1_EN)
            | LBITFIELD_SET(CHIP_REGFLD_RCC_APB2ENR_TIM8_EN,    CHIP_CLK_TIM8_EN)
            | LBITFIELD_SET(CHIP_REGFLD_RCC_APB2ENR_USART1_EN,  CHIP_CLK_USART1_EN)
#if CHIP_DEV_SUPPORT_UART6
            | LBITFIELD_SET(CHIP_REGFLD_RCC_APB2ENR_UART6_EN,   CHIP_CLK_UART6_EN)
#endif
            ;


    CHIP_REGS_RCC->APB1ENR |=  (CHIP_REGS_RCC->APB1ENR & ~CHIP_REGMSK_RCC_APB1ENR_RESERVED)
            | LBITFIELD_SET(CHIP_REGFLD_RCC_APB1ENR_TIM3_EN,    CHIP_CLK_TIM3_EN)
#if CHIP_DEV_SUPPORT_TIM4
            | LBITFIELD_SET(CHIP_REGFLD_RCC_APB1ENR_TIM4_EN,    CHIP_CLK_TIM4_EN)
#endif
            | LBITFIELD_SET(CHIP_REGFLD_RCC_APB1ENR_LPTIM_EN,   CHIP_CLK_LPTIM_EN)
            | LBITFIELD_SET(CHIP_REGFLD_RCC_APB1ENR_TIM6_EN,    CHIP_CLK_TIM6_EN)
            | LBITFIELD_SET(CHIP_REGFLD_RCC_APB1ENR_BEEP1_EN,   CHIP_CLK_BEEP1_EN)
#if CHIP_DEV_BEEPER_CNT >= 2
            | LBITFIELD_SET(CHIP_REGFLD_RCC_APB1ENR_BEEP2_EN,   CHIP_CLK_BEEP2_EN)
#endif
            | LBITFIELD_SET(CHIP_REGFLD_RCC_APB1ENR_COMP_EN,    CHIP_CLK_COMP_EN)
            | LBITFIELD_SET(CHIP_REGFLD_RCC_APB1ENR_COMPFILT_EN,CHIP_CLK_COMP_EN)
#if CHIP_DEV_SUPPORT_TSC
            | LBITFIELD_SET(CHIP_REGFLD_RCC_APB1ENR_TSC_EN,     CHIP_CLK_TSC_EN)
#endif
            | LBITFIELD_SET(CHIP_REGFLD_RCC_APB1ENR_WWDG_EN,    CHIP_CLK_WWDG_EN)
            | LBITFIELD_SET(CHIP_REGFLD_RCC_APB1ENR_USART2_EN,  CHIP_CLK_USART2_EN)
            | LBITFIELD_SET(CHIP_REGFLD_RCC_APB1ENR_LPUART1_EN, CHIP_CLK_LPUART1_EN)
#if CHIP_DEV_LPUART_CNT >= 2
            | LBITFIELD_SET(CHIP_REGFLD_RCC_APB1ENR_LPUART2_EN, CHIP_CLK_LPUART2_EN)
#endif
#if CHIP_DEV_SUPPORT_UART5
            | LBITFIELD_SET(CHIP_REGFLD_RCC_APB1ENR_UART5_EN,   CHIP_CLK_UART5_EN)
#endif
            | LBITFIELD_SET(CHIP_REGFLD_RCC_APB1ENR_I2C1_EN,    CHIP_CLK_I2C1_EN)
            | LBITFIELD_SET(CHIP_REGFLD_RCC_APB1ENR_I2C2_EN,    CHIP_CLK_I2C2_EN)
#if CHIP_DEV_CAN_CNT >= 1
            | LBITFIELD_SET(CHIP_REGFLD_RCC_APB1ENR_CAN1_EN,    CHIP_CLK_CAN1_EN)
#endif
            | LBITFIELD_SET(CHIP_REGFLD_RCC_APB1ENR_PWR_EN,     CHIP_CLK_PWR_EN)
            | LBITFIELD_SET(CHIP_REGFLD_RCC_APB1ENR_OPA_EN,     CHIP_CLK_OPA_EN)
            ;

#if CHIP_CLK_ADC_EN
    /* выбор источника клока АЦП выполняем только если ADC_EN = 1, т.к. без
     * разрешения АЦП регистры блока недоступны */
    LBITFIELD_UPD(CHIP_REGS_ADC1->CR3, CHIP_REGFLD_ADC_CR3_CKMOD, CHIP_RVAL_ADC_CR3_CKMOD);
#endif
#if CHIP_CLK_MCO_EN
    CHIP_PIN_CONFIG(CHIP_CLK_MCO_PIN);
#endif

#if CHIP_LTIMER_EN
    /* разрешение ltimer */
    lclock_init();
#endif
}

